## opengv 1.0+1git91f4b1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.3)
project(opengv VERSION 1.0 LANGUAGES CXX)

# Set the build type.  Options are:
#
#  None (CMAKE_C_FLAGS or CMAKE_CXX_FLAGS used)
#  Debug (CMAKE_C_FLAGS_DEBUG or CMAKE_CXX_FLAGS_DEBUG)
#  Release (CMAKE_C_FLAGS_RELEASE or CMAKE_CXX_FLAGS_RELEASE)
#  RelWithDebInfo (CMAKE_C_FLAGS_RELWITHDEBINFO or CMAKE_CXX_FLAGS_RELWITHDEBINFO)
#  MinSizeRel (CMAKE_C_FLAGS_MINSIZEREL or CMAKE_CXX_FLAGS_MINSIZEREL)

set(CMAKE_BUILD_TYPE Release)

#set the default path for built executables to the "bin" directory
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
#set the default path for built libraries to the "lib" directory
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

OPTION(BUILD_TESTS "Build tests" ON)
OPTION(BUILD_PYTHON "Build Python extension" OFF)

IF(MSVC)
  set(BUILD_SHARED_LIBS OFF)
ELSE()
  OPTION(BUILD_SHARED_LIBS "Build shared libraries" OFF)
  OPTION(BUILD_POSITION_INDEPENDENT_CODE "Build position independent code (-fPIC)" ON)
ENDIF()

IF(MSVC)
  add_compile_options(/wd4514 /wd4267 /bigobj)
  add_definitions(-D_USE_MATH_DEFINES)
ELSE()
  IF (CMAKE_SYSTEM_PROCESSOR MATCHES "(arm64)|(ARM64)|(aarch64)|(AARCH64)")
    add_definitions (-march=armv8-a)
  ELSEIF (CMAKE_SYSTEM_PROCESSOR MATCHES 
          "(arm)|(ARM)|(armhf)|(ARMHF)|(armel)|(ARMEL)")
    add_definitions (-march=armv7-a)
  ELSE ()
    add_definitions (-march=native) #TODO use correct c++11 def once everybody has moved to gcc 4.7 # for now I even removed std=gnu++0x
  ENDIF()
  add_definitions (
    -O3
    -Wall
    -Wextra
    #-Werror
    -Wwrite-strings
    -Wno-unused-parameter
    -fno-strict-aliasing
  )
ENDIF()

IF(BUILD_POSITION_INDEPENDENT_CODE)
  add_definitions( -fPIC )
ENDIF()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/modules/")
find_package(Eigen REQUIRED)
set(ADDITIONAL_INCLUDE_DIRS ${EIGEN_INCLUDE_DIRS} ${EIGEN_INCLUDE_DIR}/unsupported)

set( OPENGV_SOURCE_FILES
  src/absolute_pose/modules/main.cpp
  src/absolute_pose/modules/gp3p/code.cpp
  src/absolute_pose/modules/gp3p/init.cpp
  src/absolute_pose/modules/gp3p/reductors.cpp
  src/absolute_pose/modules/gp3p/spolynomials.cpp
  src/absolute_pose/modules/Epnp.cpp
  src/absolute_pose/modules/gpnp1/code.cpp
  src/absolute_pose/modules/gpnp1/init.cpp
  src/absolute_pose/modules/gpnp1/reductors.cpp
  src/absolute_pose/modules/gpnp1/spolynomials.cpp
  src/absolute_pose/modules/gpnp2/code.cpp
  src/absolute_pose/modules/gpnp2/init.cpp
  src/absolute_pose/modules/gpnp2/reductors.cpp
  src/absolute_pose/modules/gpnp2/spolynomials.cpp
  src/absolute_pose/modules/gpnp3/code.cpp
  src/absolute_pose/modules/gpnp3/init.cpp
  src/absolute_pose/modules/gpnp3/reductors.cpp
  src/absolute_pose/modules/gpnp3/spolynomials.cpp
  src/absolute_pose/modules/gpnp4/code.cpp
  src/absolute_pose/modules/gpnp4/init.cpp
  src/absolute_pose/modules/gpnp4/reductors.cpp
  src/absolute_pose/modules/gpnp4/spolynomials.cpp
  src/absolute_pose/modules/gpnp5/code.cpp
  src/absolute_pose/modules/gpnp5/init.cpp
  src/absolute_pose/modules/gpnp5/reductors.cpp
  src/absolute_pose/modules/gpnp5/spolynomials.cpp
  src/absolute_pose/modules/upnp2.cpp
  src/absolute_pose/modules/upnp4.cpp
  src/relative_pose/modules/main.cpp
  src/relative_pose/modules/fivept_nister/modules.cpp
  src/relative_pose/modules/fivept_stewenius/modules.cpp
  src/relative_pose/modules/fivept_kneip/code.cpp
  src/relative_pose/modules/fivept_kneip/init.cpp
  src/relative_pose/modules/fivept_kneip/reductors.cpp
  src/relative_pose/modules/fivept_kneip/spolynomials.cpp
  src/relative_pose/modules/sixpt/modules2.cpp
  src/relative_pose/modules/eigensolver/modules.cpp
  src/relative_pose/modules/ge/modules.cpp
  src/math/cayley.cpp
  src/math/quaternion.cpp
  src/math/arun.cpp
  src/math/Sturm.cpp
  src/math/roots.cpp
  src/math/gauss_jordan.cpp
  src/absolute_pose/methods.cpp
  src/absolute_pose/CentralAbsoluteAdapter.cpp
  src/absolute_pose/NoncentralAbsoluteAdapter.cpp
  src/absolute_pose/NoncentralAbsoluteMultiAdapter.cpp
  src/relative_pose/methods.cpp
  src/relative_pose/CentralRelativeAdapter.cpp
  src/relative_pose/CentralRelativeWeightingAdapter.cpp
  src/relative_pose/NoncentralRelativeAdapter.cpp
  src/relative_pose/CentralRelativeMultiAdapter.cpp
  src/relative_pose/NoncentralRelativeMultiAdapter.cpp
  src/triangulation/methods.cpp
  src/point_cloud/methods.cpp
  src/point_cloud/PointCloudAdapter.cpp
  src/sac_problems/absolute_pose/AbsolutePoseSacProblem.cpp
  src/sac_problems/absolute_pose/MultiNoncentralAbsolutePoseSacProblem.cpp
  src/sac_problems/relative_pose/CentralRelativePoseSacProblem.cpp
  src/sac_problems/relative_pose/NoncentralRelativePoseSacProblem.cpp
  src/sac_problems/relative_pose/RotationOnlySacProblem.cpp
  src/sac_problems/relative_pose/TranslationOnlySacProblem.cpp
  src/sac_problems/relative_pose/EigensolverSacProblem.cpp
  src/sac_problems/relative_pose/MultiCentralRelativePoseSacProblem.cpp
  src/sac_problems/relative_pose/MultiNoncentralRelativePoseSacProblem.cpp
  src/sac_problems/point_cloud/PointCloudSacProblem.cpp
  src/absolute_pose/MACentralAbsolute.cpp
  src/absolute_pose/MANoncentralAbsolute.cpp
  src/relative_pose/MACentralRelative.cpp
  src/relative_pose/MANoncentralRelative.cpp
  src/relative_pose/MANoncentralRelativeMulti.cpp
  src/point_cloud/MAPointCloud.cpp )

set( OPENGV_HEADER_FILES
  include/opengv/types.hpp
  include/opengv/OptimizationFunctor.hpp
  include/opengv/absolute_pose/methods.hpp
  include/opengv/relative_pose/methods.hpp
  include/opengv/triangulation/methods.hpp
  include/opengv/point_cloud/methods.hpp
  include/opengv/math/cayley.hpp
  include/opengv/math/quaternion.hpp
  include/opengv/math/arun.hpp
  include/opengv/math/Sturm.hpp
  include/opengv/math/roots.hpp
  include/opengv/math/gauss_jordan.hpp
  include/opengv/absolute_pose/AbsoluteAdapterBase.hpp
  include/opengv/absolute_pose/CentralAbsoluteAdapter.hpp
  include/opengv/absolute_pose/NoncentralAbsoluteAdapter.hpp
  include/opengv/absolute_pose/NoncentralAbsoluteMultiAdapter.hpp
  include/opengv/absolute_pose/AbsoluteMultiAdapterBase.hpp
  include/opengv/relative_pose/RelativeAdapterBase.hpp
  include/opengv/relative_pose/RelativeMultiAdapterBase.hpp
  include/opengv/relative_pose/CentralRelativeAdapter.hpp
  include/opengv/relative_pose/CentralRelativeWeightingAdapter.hpp
  include/opengv/relative_pose/NoncentralRelativeAdapter.hpp
  include/opengv/relative_pose/CentralRelativeMultiAdapter.hpp
  include/opengv/relative_pose/NoncentralRelativeMultiAdapter.hpp
  include/opengv/point_cloud/PointCloudAdapterBase.hpp
  include/opengv/point_cloud/PointCloudAdapter.hpp
  include/opengv/sac_problems/absolute_pose/AbsolutePoseSacProblem.hpp
  include/opengv/sac_problems/absolute_pose/MultiNoncentralAbsolutePoseSacProblem.hpp
  include/opengv/sac_problems/relative_pose/CentralRelativePoseSacProblem.hpp
  include/opengv/sac_problems/relative_pose/NoncentralRelativePoseSacProblem.hpp
  include/opengv/sac_problems/relative_pose/MultiCentralRelativePoseSacProblem.hpp
  include/opengv/sac_problems/relative_pose/MultiNoncentralRelativePoseSacProblem.hpp
  include/opengv/sac_problems/relative_pose/EigensolverSacProblem.hpp
  include/opengv/sac_problems/relative_pose/RotationOnlySacProblem.hpp
  include/opengv/sac_problems/relative_pose/TranslationOnlySacProblem.hpp
  include/opengv/sac_problems/point_cloud/PointCloudSacProblem.hpp
  include/opengv/absolute_pose/MACentralAbsolute.hpp
  include/opengv/absolute_pose/MANoncentralAbsolute.hpp
  include/opengv/relative_pose/MACentralRelative.hpp
  include/opengv/relative_pose/MANoncentralRelative.hpp
  include/opengv/relative_pose/MANoncentralRelativeMulti.hpp
  include/opengv/point_cloud/MAPointCloud.hpp )

add_library( opengv ${OPENGV_SOURCE_FILES} ${OPENGV_HEADER_FILES} )
add_library( random_generators test/random_generators.cpp test/random_generators.hpp test/experiment_helpers.cpp test/experiment_helpers.hpp test/time_measurement.cpp test/time_measurement.hpp )
set_target_properties( opengv random_generators PROPERTIES
                    SOVERSION ${PROJECT_VERSION}
                    VERSION ${PROJECT_VERSION}
                    CXX_STANDARD 11
                    CXX_STANDARD_REQUIRED ON
                    DEBUG_POSTFIX d )

target_include_directories( opengv PUBLIC 
                # only when building from the source tree
                $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
                # only when using the lib from the install path
                $<INSTALL_INTERFACE:include>
                ${ADDITIONAL_INCLUDE_DIRS} )

target_include_directories( random_generators PRIVATE ${ADDITIONAL_INCLUDE_DIRS} )

target_link_libraries( random_generators opengv )

IF (BUILD_TESTS)
  enable_testing()
  include_directories( ${ADDITIONAL_INCLUDE_DIRS} )

  add_executable( test_absolute_pose test/test_absolute_pose.cpp )
  target_link_libraries( test_absolute_pose opengv random_generators )
  add_test(NAME test_absolute_pose
    WORKING_DIRECTORY ${EXECUTABLE_OUTPUT_PATH}
    COMMAND test_absolute_pose)

  add_executable( test_absolute_pose_sac test/test_absolute_pose_sac.cpp )
  target_link_libraries( test_absolute_pose_sac opengv random_generators )
  add_test(NAME test_absolute_pose_sac
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND test_absolute_pose_sac)

  add_executable( test_noncentral_absolute_pose test/test_noncentral_absolute_pose.cpp )
  target_link_libraries( test_noncentral_absolute_pose opengv random_generators )
  add_test(NAME test_noncentral_absolute_pose
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND test_noncentral_absolute_pose)

  add_executable( test_noncentral_absolute_pose_sac test/test_noncentral_absolute_pose_sac.cpp )
  target_link_libraries( test_noncentral_absolute_pose_sac opengv random_generators )
  add_test(NAME test_noncentral_absolute_pose_sac
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND test_noncentral_absolute_pose_sac)

  add_executable( test_multi_noncentral_absolute_pose_sac test/test_multi_noncentral_absolute_pose_sac.cpp )
  target_link_libraries( test_multi_noncentral_absolute_pose_sac opengv random_generators )
  add_test(NAME test_multi_noncentral_absolute_pose_sac
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND test_multi_noncentral_absolute_pose_sac)

  add_executable( test_relative_pose test/test_relative_pose.cpp )
  target_link_libraries( test_relative_pose opengv random_generators )
  add_test(NAME test_relative_pose
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND test_relative_pose)

  add_executable( test_relative_pose_rotationOnly test/test_relative_pose_rotationOnly.cpp )
  target_link_libraries( test_relative_pose_rotationOnly opengv random_generators )
  add_test(NAME test_relative_pose_rotationOnly
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND test_relative_pose_rotationOnly)

  add_executable( test_relative_pose_rotationOnly_sac test/test_relative_pose_rotationOnly_sac.cpp )
  target_link_libraries( test_relative_pose_rotationOnly_sac opengv random_generators )
  add_test(NAME test_relative_pose_rotationOnly_sac
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND test_relative_pose_rotationOnly_sac)

  add_executable( test_relative_pose_sac test/test_relative_pose_sac.cpp )
  target_link_libraries( test_relative_pose_sac opengv random_generators )
  add_test(NAME test_relative_pose_sac
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND test_relative_pose_sac)

  add_executable( test_noncentral_relative_pose test/test_noncentral_relative_pose.cpp )
  target_link_libraries( test_noncentral_relative_pose opengv random_generators )
  add_test(NAME test_noncentral_relative_pose
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    COMMAND test_noncentral_relative_pose)

  add_executable( test_noncentral_relative_pose_sac test/test_noncentral_relative_pose_sac.cpp )

=== python/CMakeLists.txt ===

add_subdirectory(pybind11)

include_directories(${PYTHON_INCLUDE_DIRS})


pybind11_add_module(pyopengv pyopengv.cpp)
target_link_libraries(pyopengv PRIVATE opengv)


# Find where to install python libs.
execute_process(COMMAND
    ${PYTHON_EXECUTABLE} -c "import distutils.sysconfig; print('/'.join(distutils.sysconfig.get_python_lib().split('/')[-3:]))"
    OUTPUT_VARIABLE PYTHON_SITE_PACKAGES OUTPUT_STRIP_TRAILING_WHITESPACE)

set(PYTHON_INSTALL_DIR
    "${CMAKE_INSTALL_PREFIX}/${PYTHON_SITE_PACKAGES}"
    CACHE PATH "Path where to install pyopengv")

install(TARGETS pyopengv DESTINATION "${PYTHON_INSTALL_DIR}")

message(python executable ${PYTHON_EXECUTABLE})

## opengv 1.0%2B1git91f4b1

=== debian/control ===
Source: opengv
Section: libdevel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 13),
               dh-python,
               pybind11-dev,
               libeigen3-dev,
               doxygen,
# for epstopdf
               texlive-font-utils,
               texlive-latex-base,
               texlive-latex-extra,
               ghostscript,
               python3-all-dev:any,
               libpython3-all-dev
Standards-Version: 4.6.1
Homepage: https://laurentkneip.github.io/opengv
Vcs-Git: https://salsa.debian.org/science-team/opengv.git
Vcs-Browser: https://salsa.debian.org/science-team/opengv

Package: libopengv1t64
Provides: ${t64:Provides}
Replaces: libopengv1
Breaks: libopengv1 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Computer vision methods for solving geometric vision problems.
 Contains absolute-pose, relative-pose, triangulation, and point-cloud alignment
 methods for the calibrated case. All problems can be solved with central or
 non-central cameras, and embedded into a random sample consensus or nonlinear
 optimization context. Matlab and Python interfaces are implemented as well
 .
 This package contains the run-time libraries

Package: libopengv-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libopengv1t64 (= ${binary:Version})
Suggests: libopengv-doc
Description: Computer vision methods for solving geometric vision problems.
 Contains absolute-pose, relative-pose, triangulation, and point-cloud alignment
 methods for the calibrated case. All problems can be solved with central or
 non-central cameras, and embedded into a random sample consensus or nonlinear
 optimization context. Matlab and Python interfaces are implemented as well
 .
 This package contains the build-time libraries

Package: python3-opengv
Section: python
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libopengv1t64 (= ${binary:Version}),
         ${python3:Depends}
Provides: ${python3:Provides}
Description: Computer vision methods for solving geometric vision problems.
 Contains absolute-pose, relative-pose, triangulation, and point-cloud alignment
 methods for the calibrated case. All problems can be solved with central or
 non-central cameras, and embedded into a random sample consensus or nonlinear
 optimization context. Matlab and Python interfaces are implemented as well
 .
 This package contains the Python interface

Package: libopengv-doc
Architecture: all
Depends: ${misc:Depends}
Description: Computer vision methods for solving geometric vision problems.
 Contains absolute-pose, relative-pose, triangulation, and point-cloud alignment
 methods for the calibrated case. All problems can be solved with central or
 non-central cameras, and embedded into a random sample consensus or nonlinear
 optimization context. Matlab and Python interfaces are implemented as well
 .
 This package contains the documentation

## opengv 1.0+1git91f4b1

=== debian/changelog ===
opengv (1.0+1git91f4b1-9ubuntu1) resolute; urgency=medium

  * d/rules: Enforce EIGEN_MAX_ALIGN_BYTES=16 for amd64v3 (LP: #2138798).

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 11 Feb 2026 10:47:24 -0500

opengv (1.0+1git91f4b1-9build1) resolute; urgency=medium

  * Another no-change rebuild with Python 3.14 for amd64v3

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 18 Jan 2026 15:27:22 +0000

opengv (1.0+1git91f4b1-9) unstable; urgency=medium

  * Support cmake 4 (Closes: 1113356)

 -- Dima Kogan <dkogan@debian.org>  Sat, 08 Nov 2025 20:02:30 -0800

opengv (1.0+1git91f4b1-8) unstable; urgency=medium

  * Added Build-Depends: python3-setuptools (Closes: #1080886)

 -- Dima Kogan <dkogan@debian.org>  Thu, 05 Sep 2024 22:16:44 -0700

opengv (1.0+1git91f4b1-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063087

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 12:19:02 +0000

opengv (1.0+1git91f4b1-7) unstable; urgency=medium

  [ Stefano Rivera ]
  * Use pybuild to build for multiple Python versions. Thanks Tyler Weaver.
    (Closes: #1024265)

 -- Dima Kogan <dkogan@debian.org>  Sat, 19 Nov 2022 14:34:50 -0800

opengv (1.0+1git91f4b1-6) unstable; urgency=medium

  * Arch:all builds work (Closes: #1020995)
  * Added Build-Depends to fully build the docs

 -- Dima Kogan <dkogan@debian.org>  Wed, 02 Nov 2022 10:34:56 -0700

opengv (1.0+1git91f4b1-5) unstable; urgency=medium

  * Source-only reupload

 -- Dima Kogan <dkogan@debian.org>  Mon, 26 Sep 2022 21:35:45 -0700

opengv (1.0+1git91f4b1-4) unstable; urgency=medium

  * don't run any tests if we're doing a system-independent build
    Hopefully fixes #1020375

 -- Dima Kogan <dkogan@debian.org>  Thu, 22 Sep 2022 17:13:34 -0700

opengv (1.0+1git91f4b1-3) unstable; urgency=medium

  * Team upload.
  * No change source-only upload for testing migration.

  [ Dima Kogan ]
  * fix typo in debian/copyright.

 -- Boyuan Yang <byang@debian.org>  Thu, 25 Aug 2022 13:02:57 -0400

opengv (1.0+1git91f4b1-2) unstable; urgency=medium

  * Initial upload into Debian (Closes: #1014132)

 -- Dima Kogan <dkogan@debian.org>  Sat, 23 Jul 2022 12:32:08 -0700

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,9 @@
 Build-Depends: dpkg-dev (>= 1.22.5), cmake,
                debhelper-compat (= 13),
                dh-python,
+# for "make install" to work. See
+#   https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1080886
+               python3-setuptools,
                pybind11-dev,
                libeigen3-dev,
                doxygen,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PYBUILD_CONFIGURE_ARGS=-DBUILD_TESTS=ON -DBUILD_PYTHON=ON -DBUILD_SHARED_LIBS=ON
export PYBUILD_SYSTEM=cmake

export DEB_CXXFLAGS_MAINT_APPEND = -DEIGEN_MAX_ALIGN_BYTES=16

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build-arch:
	dh_auto_build -a

override_dh_auto_build-indep:
	doxygen

# no system-independent tests
override_dh_auto_test-indep:
	true

override_dh_auto_install-arch:
	dh_auto_install

override_dh_auto_install-indep:
	true

override_dh_auto_clean:
	dh_auto_clean
	rm -rf doc/html doc/latex
